/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.mvc.IModel;
import com.bourre.mvc.IView;
import com.bourre.mvc.IController;

class com.bourre.mvc.AbstractController implements IController
{
	private var _oView:IView;
	private var _oModel:IModel;
	
	private function AbstractController()
	{
		//
	}
	
	public function setModel(oModel:IModel) : Void
	{
		_oModel = oModel;
	}
	
	public function getModel() : IModel
	{
		return _oModel;
	}
	
	public function setView(oView:IView) : Void
	{
		_oView = oView;
	}
	
	public function getView() : IView
	{
		return _oView;
	}
}