/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.mvc.IModel;
import com.bourre.mvc.IController;
import com.bourre.mvc.IView;

import com.bourre.mvc.AbstractModel;

class com.bourre.mvc.AbstractView implements IView
{
	private var _oController:IController;
	private var _mcContainer:MovieClip;
	
	private function AbstractView(oModel:IModel, oController:IController, mcContainer:MovieClip)
	{
		setModel(oModel);
		setController(oController);
		setViewContainer(mcContainer);
	}
	
	public function registerWithModel( oModel:IModel ) : Void
	{
		AbstractModel( oModel ).addModelListener(this);
	}
	
	public function getController() : IController
	{
		return _oController;
	}
	
	public function setController(oController:IController) : Void
	{
		_oController = oController;
	}
	
	public function setModel(oModel:IModel) : Void
	{
		registerWithModel( oModel );
	}
	 
	public function setViewContainer(mcContainer:MovieClip) : Void
	{
		_mcContainer = mcContainer? mcContainer : _root;
	}
	
	public function getViewContainer() : MovieClip
	{
		return _mcContainer;
	}
}