import com.bourre.structures.*;

class com.bourre.structures.BGrid extends AbstractGrid
{

	public function BGrid (nX:Number, nY:Number) 
	{
		super(nX, nY);
	}
	
	public function getVal(v:Point) : Boolean
	{
		checkGridCoords(v);
		return _aContent[v.x][v.y];
	}
	
	public function setVal(v:Point, b:Boolean) : Void
	{
		checkGridCoords(v);
		_aContent[v.x][v.y] = b; 
	}
	
	public function serialize() : String
	{
		var s:String = "";
		var i = getIterator();
		while(i.hasNext()) s += i.next() ? "1" : "0";
		return s;
	}
	
	public function deserialize(s:String) : Void
	{
		var a:Array = s.split("");
		setContent(a);
	}
	
	public function getRowVal(n:Number) : Boolean
	{
		var a:Array = getRow(n); 
		var l:Number = getSize().x;
		for (var i:Number = 0; i<l; i++) if (!a[i]) return false;
		return true;
	}
	
	public function getColumnVal(n:Number) : Boolean
	{
		var a:Array = getColumn(n);
		var l:Number = getSize().y;
		for (var i:Number = 0; i<l; i++) if (!a[i]) return false;
		return true;
	}
	
	/**
	 * Sets content of tilemap with array of String objects.<br><br>
	 */
	public function setContent(a:Array) : Void
	{
		if(a.length != getArea()) trace("Array size mismatches with BGrid size!");
		
		var i = getIterator();
		while (i.hasNext())
		{
			i.next();
			setVal(i, a[i.getIndex()] == "1");
		}
	}
}