/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

class com.bourre.core.HashCodeFactory
{
	private static var _nKEY:Number = 0;
	private static var _bInitialized:Boolean = HashCodeFactory._initialize(Object.prototype);
	
	private function HashCodeFactory()
	{
		//
	}
	
	public static function getNextKEY() : Number
	{
		return HashCodeFactory._nKEY++;
	}
	
	private static function _initialize(o) : Boolean
	{
		o.__getKEY = function () 
		{
			this.__nKEY = null;
			if (this.__nKEY == null) 
			{
				this.__nKEY = HashCodeFactory.getNextKEY();
				_global.ASSetPropFlags(this, ["__nKEY", "__KEY", "__getKEY"], 7, 1);
			}
			return this.__nKEY;
		};
		o.addProperty('__KEY', o.__getKEY, null);
		_global.ASSetPropFlags(o, ["__nKEY", "__KEY", "__getKEY"], 7, 1);
		
		return true;
	}
	
	public static function getNextName() : String
	{
		return String( HashCodeFactory._nKEY + 1 );
	}
	
	public static function getKey(o) : Number
	{
		return o.__KEY;
	}
	
	public static function isSameObject(a, b) : Boolean
	{
		return HashCodeFactory.getKey(a) == HashCodeFactory.getKey(b);
	}
	
	public static function buildInstance(sPackage:String, aArgs:Array)
	{
		var clazz:Function = eval("_global." + sPackage);
		var o = {__constructor__:clazz, __proto__:clazz.prototype};
		clazz.apply(o, aArgs);
		return o;
	}
}