/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.events.*;

interface com.bourre.events.IEventDispatcher
{
	/**
	 * Wrapper for EventDispatcher compatibility.<br><br>
	 * <strong>Usage :</strong> <em>e.dispatchEvent( {type:'onSomething', target:this, param:12} );</em>
	 * @param o Event object.
	 */
	public function dispatchEvent(o:Object) : Void;
	
	/**
	 * Broadcast event to suscribed listeners.<br><br>
	 * <strong>Usage :</strong> <em>e.broadcastEvent( new BasicEvent(MyClass.onSomethingEVENT) );</em>
	 * @param e IEvent. Event object must implement IEvent interface.
	 */
	public function broadcastEvent(e:IEvent) : Void;
}