/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.transitions.TweenEvent;

interface com.bourre.transitions.ITweenListener
{
	/**
	 * Callback when tween starts.<br><br>
	 * @param e TweenEvent.<br><br>
	 */
	public function onStart(e:TweenEvent) : Void;
	
	/**
	 * Callback when tween stops.<br><br>
	 * @param e TweenEvent.<br><br>
	 */
	public function onStop(e:TweenEvent) : Void;
	
	/**
	 * Callback when tween ends.<br><br>
	 * @param e TweenEvent.<br><br>
	 */
	public function onMotionFinished(e:TweenEvent) : Void;
	
	/**
	 * Callback when object property value is updated.<br><br>
	 * @param e TweenEvent.<br><br>
	 */
	public function onMotionChanged(e:TweenEvent) : Void;
}