/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.log.*;

class com.bourre.log.LogLevel extends Number
{
	public static var DEBUG:LogLevel = new LogLevel("DEBUG", 0);
	public static var INFO:LogLevel = new LogLevel("INFO", 1);
	public static var WARN:LogLevel = new LogLevel("WARN", 2);
	public static var ERROR:LogLevel = new LogLevel("ERROR", 3);
	public static var FATAL:LogLevel = new LogLevel("FATAL", 4);
	
	private var _sName:String;
	private var _nLevel:Number;

	public function LogLevel(sName:String, nLevel:Number)
	{
		super(nLevel);
		_sName = sName;
		_nLevel = nLevel;
	}
	
	public function getName() : String
	{
		return _sName;
	}
	
	public function getLevel() : Number
	{
		return _nLevel;
	}
	
	public function isEnabled() : Boolean
	{
		return _nLevel >= Logger.GETLEVEL();
	}
}