/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.log.*;

class com.bourre.log.Logger
{
	private static var _oI:Logger;
	private var level:LogLevel;
	private var _e:LogEvent;

	private var addListener:Function;
	private var removeListener:Function;
	private var broadcastMessage:Function;
	private var _listeners:Array;
	
	private function Logger()
	{
		AsBroadcaster.initialize(this);
		level = LogLevel.DEBUG;
		_e = new LogEvent(level, "");
		
		//addLogListener( com.bourre.utils.SosTracer.getInstance() );
		//addLogListener( com.bourre.utils.LuminicTracer.getInstance() );
	}
	
	public static function LOG(o, oLevel:LogLevel) : Void
	{
		getInstance().log( o, oLevel );
	}
	
	public static function SETLEVEL(oLevel:LogLevel) : Void
	{
		getInstance().level =  oLevel;
	}
	
	public static function GETLEVEL() : LogLevel
	{
		return getInstance().level;
	}
	
	private static function _init() : Logger
	{
		_oI = new Logger();
		return _oI;
	}
	
	public static function getInstance() : Logger
	{
		return (_oI != undefined) ? _oI : Logger._init();
	}

	public function addLogListener(o:LogListener) : Void
	{
		addListener( o );
	}
	
	public function removeLogListener(o:LogListener) : Void
	{
		removeListener( o );
	}
	
	public function log(o, oLevel:LogLevel) : Void
	{	
		if (oLevel == undefined) oLevel = LogLevel.DEBUG;
		_e.content = o ;
		_e.level = oLevel;
		if (oLevel.isEnabled()) broadcastMessage( _e.getType(), _e );
	}
}