import com.bourre.structures.*;

class com.bourre.structures.NGrid extends AbstractGrid
{

	public function NGrid (nX:Number, nY:Number) 
	{
		super(nX, nY);
	}
	
	public function getVal(v:Point) : Number
	{
		checkGridCoords(v);
		return _aContent[v.x][v.y];
	}
	
	public function setVal(v:Point, n:Number) : Void
	{
		checkGridCoords(v);
		_aContent[v.x][v.y] = n; 
	}
	
	public function serialize(sCharSep:String, sUndefined:String) : String
	{
		sCharSep = (sCharSep == undefined) ? "," : sCharSep;
		sUndefined = (sUndefined == undefined) ? "_" : sUndefined;
		var s:String = "";
		
		var i = getIterator();
		while(i.hasNext())
		{
			var n:Number = i.next();
			s += ( n == undefined ) ? sUndefined + sCharSep : String(n) + sCharSep;
		}
		return s.substr(0, s.length - sCharSep.length);
	}
	
	public function deserialize(s:String, sCharSep:String, sUndefined:String) : Void
	{
		sCharSep = (sCharSep == undefined) ? "," : sCharSep;
		sUndefined = (sUndefined == undefined) ? "_" : sUndefined;
		
		var a:Array = s.split(sCharSep);
		setContent(a, sUndefined);
	}
	
	/**
	 * Sets content of tilemap with array of String objects.<br><br>
	 */
	public function setContent(a:Array, sUndefined:String) : Void
	{
		if(a.length != getArea()) throw new Error("Array size mismatches with NGrid size!");
		
		var n:Number;
		var s:String;
		var i = getIterator();
		
		while (i.hasNext())
		{
			i.next();
			s = a[i.getIndex()];
			n = Number(s);
			if (s != sUndefined && !isNaN(n)) setVal(i, n);
		}
	}
}