/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */
 
import com.bourre.structures.*;

class com.bourre.structures.Rectangle
{
	public var width : Number;
	public var height : Number;
	public var x : Number;
	public var y : Number;
	
	public var center:Point;
	public var topLeft:Point;
	public var topRight:Point;
	public var bottomLeft:Point;
	public var bottomRight:Point;
	
	function Rectangle(w:Number, h:Number, x:Number, y:Number) 
	{
		width = w;
		height = h;
		this.x = x;
		this.y = y;
	}
	
	public function getTopLeft() : Point
	{
		return new Point(x, y);
	}
	
	public function getTopRight() : Point
	{
		return new Point(x + width, y);
	}
	
	public function getBottomLeft() : Point
	{
		return new Point(x, y + height);
	}
	
	public function getBottomRight() : Point
	{
		return new Point( x+width, y+height);
	}
	
	public function getCenter() : Point
	{
		return new Point(x + width/2, y + height/2);
	}
	
	public function toString() : String
	{
		return "Rectangle";
	}
}