import com.bourre.structures.*;

class com.bourre.structures.SGrid extends AbstractGrid
{

	public function SGrid (nX:Number, nY:Number) 
	{
		super(nX, nY);
	}
	
	public function getVal(v:Point) : String
	{
		checkGridCoords(v);
		return _aContent[v.x][v.y];
	}
	
	public function setVal(v:Point, s:String) : Void
	{
		checkGridCoords(v);
		_aContent[v.x][v.y] = s; 
	}
	
	public function permute(v1:Point, v2:Point) : Void
	{
		var s1:String = getVal(v1);
		setVal(v1, getVal(v2));
		setVal(v2, s1);
	}
	
	public function serialize(sCharSep:String, sUndefined:String) : String
	{
		sCharSep = (sCharSep == undefined) ? "," : sCharSep;
		sUndefined = (sUndefined == undefined) ? "_" : sUndefined;
		var s:String = "";
		
		var i = getIterator();
		while(i.hasNext())
		{
			var w:String = i.next();
			s += ( w == undefined ) ? sUndefined + sCharSep : w + sCharSep;
		}
		return s.substr(0, s.length - sCharSep.length);
	}
	
	public function deserialize(s:String, sCharSep:String, sUndefined:String) : Void
	{
		sCharSep = (sCharSep == undefined) ? "," : sCharSep;
		sUndefined = (sUndefined == undefined) ? "_" : sUndefined;
		
		var a:Array = s.split(sCharSep);
		setContent(a, sUndefined);
	}
	
	/**
	 * Sets content of tilemap with array of String objects.<br><br>
	 */
	public function setContent(a:Array, sUndefined:String) : Void
	{
		if (a.length != getArea()) trace("Array size mismatches with SGrid size!");
		
		var s:String;
		var i = getIterator();
		
		while (i.hasNext())
		{
			i.next();
			s = a[i.getIndex()];
			if (s != sUndefined) setVal(i, s);
		}
	}
}