/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.medias.sound.SoundFactory;

class com.bourre.medias.sound.SoundFactoryManager 
	extends SoundFactory
{
	private static var _oI:SoundFactoryManager;
	
	private function SoundFactoryManager()
	{
		super();
	}
	
	private static function _buildInstance() : SoundFactoryManager
	{
		SoundFactoryManager._oI = new SoundFactoryManager();
		return _oI;
	}
	
	public static function getInstance() : SoundFactoryManager
	{
		return (SoundFactoryManager._oI instanceof SoundFactoryManager) ? SoundFactoryManager._oI : SoundFactoryManager._buildInstance();
	}
	
	public static function release() : Void
	{
		_oI.clear();
		delete _oI;
	}
}