/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
 /**
 * @author Francis Bourre
 * @version 1.0
 */

import com.bourre.events.*;

class com.bourre.transitions.TweenEventType extends EventType
{
	// Event types
	
	/**
	@summary Broadcasted to listeners when tween starts.<br>
	@see com.bourre.transitions.TweenEvent
	 */
	[Event("onStart")]
	public static var onStartEVENT:TweenEventType = new TweenEventType("onStart");
	
	/**
	@summary Broadcasted to listeners when tween stops.<br>
	@see com.bourre.transitions.TweenEvent
	 */
	[Event("onStop")]
	public static var onStopEVENT:TweenEventType = new TweenEventType("onStop");
	
	/**
	@summary Broadcasted to listeners when tween is finished.<br>
	@see com.bourre.transitions.TweenEvent
	 */
	[Event("onMotionFinished")]
	public static var onMotionFinishedEVENT:TweenEventType = new TweenEventType("onMotionFinished");
	
	/**
	@summary Broadcasted to listeners when property value is updated.<br>
	@see com.bourre.transitions.TweenEvent
	 */
	[Event("onMotionChanged")]
	public static var onMotionChangedEVENT:TweenEventType = new TweenEventType("onMotionChanged");
	
	//
	
	public function TweenEventType(s:String)
	{
		super(s);
	}
}